/// =========================================================================
/// AUTO-GENERATED FILE CREATED ON 2022-08-01T14:42:03.409344
/// THIS FILE WAS AUTOMATICALLY GENERATED, MODIFICATIONS WILL BE OVERWRITTEN.
/// =========================================================================

part of pco;

/// Ordering is not allowed on this object.
enum PcoServicesBlockoutDateOrder { none }

/// Filtering is not allowed when requesting this object.
enum PcoServicesBlockoutDateFilter { none }

/// Creates a [PcoServicesBlockoutDateQuery] object
///
/// ## Extra Params
/// Many API queries accept extra parameters too. The `extraParams` mapping will translate directly to url parameters.
class PcoServicesBlockoutDateQuery extends PlanningCenterApiQuery {
  static final Map<PcoServicesBlockoutDateOrder, String> _orderMap = {};
  static String orderString(PcoServicesBlockoutDateOrder order,
          {bool reverse = false}) =>
      (reverse ? '-' : '') + _orderMap[order]!;

  static final Map<PcoServicesBlockoutDateFilter, String> _filterMap = {};
  static String filterString(PcoServicesBlockoutDateFilter filter) =>
      _filterMap[filter]!;

  PcoServicesBlockoutDateQuery({
    /// reverse the ordering
    bool reverse = false,

    // direct access to super class params
    super.perPage,
    super.pageOffset,
    super.extraParams,
    super.where,
    super.filter,
    super.order,
    super.include,
  }) : super();
}

/// This class represents a PCO Services BlockoutDate Object
///
/// - Application:        services
/// - Id:                 blockout_date
/// - Type:               BlockoutDate
/// - ApiVersion:         2018-11-01
/// - Is Deprecated:      false
/// - Is Collection Only: false
/// - Default Endpoint:   https://api.planningcenteronline.com/services/v2/people/1/blockout_dates
/// - Create Endpoint:    NONE
///
/// ## Instantiation
/// - This object cannot be created through the API.
/// - Instantiate from existing `JSON` data using the `PcoServicesBlockoutDate.fromJson()` constructor.
/// - Load an instance from the API using one of the static methods defined on this class.
///
/// ## Usage
/// - Fields exposed by the API are readable through getter methods.
/// - Fields writable by the API are exposed through setter methods.
/// - Original `json` data is exposed through the read-only `attributes` map.
/// - Additional data is available through the read-only `links` and `relationships` maps.
/// - Available relationships / includes are exposed through typed getters.
///
///
/// ## Description
/// The actual dates generated by the blockout or its recurrence pattern. Generated up to a year in advance
///
/// ## Attributes (and permissions)
/// - `id` (ro) -> PCO: `id`
/// - `groupIdentifier` (ro) -> PCO: `group_identifier`
/// - `reason` (ro) -> PCO: `reason`
/// - `timeZone` (ro) -> PCO: `time_zone`
/// - `isShare` (ro) -> PCO: `share`
/// - `startsAt` (ro) -> PCO: `starts_at`
/// - `endsAt` (ro) -> PCO: `ends_at`
/// - `endsAtUtc` (ro) -> PCO: `ends_at_utc`
/// - `startsAtUtc` (ro) -> PCO: `starts_at_utc`
///
/// ## Edges and Actions
///
/// Outbound Edges:
/// NONE
///
/// Inbound Edges:
/// - `blockoutdate-blockout-blockout_dates`: https://api.planningcenteronline.com/services/v2/people/1/blockouts/1/blockout_dates
///
/// Actions:
/// NONE
///
/// ## Raw Data Object Example
/// ```json
/// {
///   "type": "BlockoutDate",
///   "id": "1",
///   "attributes": {
///     "group_identifier": "string",
///     "reason": "string",
///     "time_zone": "string",
///     "share": true,
///     "starts_at": "2000-01-01T12:00:00Z",
///     "ends_at": "2000-01-01T12:00:00Z",
///     "ends_at_utc": "2000-01-01T12:00:00Z",
///     "starts_at_utc": "2000-01-01T12:00:00Z"
///   },
///   "relationships": {
///     "person": {
///       "data": {
///         "type": "Person",
///         "id": "1"
///       }
///     },
///     "blockout": {
///       "data": {
///         "type": "Blockout",
///         "id": "1"
///       }
///     }
///   }
/// }
/// ```
class PcoServicesBlockoutDate extends PcoResource {
  static const String kPcoApplication = 'services';
  static const String kTypeString = 'BlockoutDate';
  static const String kTypeId = 'blockout_date';
  static const String kApiVersion = '2018-11-01';
  static const String kDefaultPathTemplate =
      'https://api.planningcenteronline.com/services/v2/people/1/blockout_dates';
  static const String kCreatePathTemplate = 'null';

  /// possible includes with parameter ?include=a,b
  ///
  static List<String> get canInclude => [];

  /// possible queries using parameters like ?where[key]=value or ?where[key][gt|lt]=value
  ///
  static List<String> get canQuery => [];

  /// possible orderings with parameter ?order=
  ///
  static List<String> get canOrderBy => [];

  // By using overridden getters, the parent class can call the getter and will get the results from the
  // child class. This lets the parent access the static variables of the child class.

  @override
  String get createPathTemplate => kCreatePathTemplate;

  @override
  String get defaultPathTemplate => kDefaultPathTemplate;

  @override
  String get apiVersion => kApiVersion;

  String? _apiPathOverride;

  @override
  String get apiPath => links['self'] ?? _apiPathOverride ?? super.apiPath;

  // field mapping constants
  static const kId = 'id';
  static const kGroupIdentifier = 'group_identifier';
  static const kReason = 'reason';
  static const kTimeZone = 'time_zone';
  static const kShare = 'share';
  static const kStartsAt = 'starts_at';
  static const kEndsAt = 'ends_at';
  static const kEndsAtUtc = 'ends_at_utc';
  static const kStartsAtUtc = 'starts_at_utc';

  // getters and setters
  @override
  List<String> get createAllowed => [];

  @override
  List<String> get updateAllowed => [];

  @override
  bool get canCreate => false;

  @override
  bool get canUpdate => false;

  @override
  bool get canDestroy => false;

  // getters for object attributes
  String get groupIdentifier => _attributes[kGroupIdentifier] ?? '';
  String get reason => _attributes[kReason] ?? '';
  String get timeZone => _attributes[kTimeZone] ?? '';
  bool get isShare => _attributes[kShare] == true;
  DateTime get startsAt => DateTime.parse(_attributes[kStartsAt] ?? '');
  DateTime get endsAt => DateTime.parse(_attributes[kEndsAt] ?? '');
  DateTime get endsAtUtc => DateTime.parse(_attributes[kEndsAtUtc] ?? '');
  DateTime get startsAtUtc => DateTime.parse(_attributes[kStartsAtUtc] ?? '');

  // Class Constructors
  PcoServicesBlockoutDate.fromJson(Map<String, dynamic> data,
      {List<Map<String, dynamic>>? withIncluded})
      : super.fromJson(kPcoApplication, kTypeString, data,
            withIncluded: withIncluded);

  /// Create an empty instance of this class. This is only useful when an endpoint requires
  /// related or included data.
  ///
  /// NOTE: This object cannot be saved directly to Planning Center
  PcoServicesBlockoutDate.empty() : super(kPcoApplication, kTypeString);

  /// Create a new [PcoServicesBlockoutDate] object. This object cannot be created with the API
  ///
  /// ### NOTES:
  /// - Creating an instance of a class this way does not save it on the server.
  /// - This object cannot be saved directly to the server.
  /// - Only set the `id` field if you know what you are doing. Save operations will overwrite data when the `id` is set.
  /// - FIELDS USED WHEN CREATING: none
  /// - FIELDS USED WHEN UPDATING: none
  /// - Dummy data can be supplied for a required parameter, but if so, `.save()` should not be called on the object
  factory PcoServicesBlockoutDate(
      {String? id,
      String? groupIdentifier,
      String? reason,
      String? timeZone,
      bool? isShare,
      DateTime? startsAt,
      DateTime? endsAt,
      DateTime? endsAtUtc,
      DateTime? startsAtUtc,
      Map<String, List<PcoResource>>? withRelationships,
      List<PcoResource>? withIncluded}) {
    var obj = PcoServicesBlockoutDate.empty();
    obj._id = id;
    if (groupIdentifier != null)
      obj._attributes['group_identifier'] = groupIdentifier;
    if (reason != null) obj._attributes['reason'] = reason;
    if (timeZone != null) obj._attributes['time_zone'] = timeZone;
    if (isShare != null) obj._attributes['share'] = isShare;
    if (startsAt != null)
      obj._attributes['starts_at'] = startsAt.toIso8601String();
    if (endsAt != null) obj._attributes['ends_at'] = endsAt.toIso8601String();
    if (endsAtUtc != null)
      obj._attributes['ends_at_utc'] = endsAtUtc.toIso8601String();
    if (startsAtUtc != null)
      obj._attributes['starts_at_utc'] = startsAtUtc.toIso8601String();

    if (withRelationships != null) {
      for (var r in withRelationships.entries) {
        obj._relationships[r.key] = r.value;
      }
      obj._hasManualRelationships = true;
    }

    if (withIncluded != null) {
      obj._included.addAll(withIncluded);
      obj._hasManualIncluded = true;
    }

    return obj;
  }

  // ---------------------------------
  // Inbound Edges
  // ---------------------------------
  // Static functions to obtain instances of this class

  /// Will get a collection of [PcoServicesBlockoutDate] objects (expecting many)
  /// using a path like this: `/services/v2/people/$personId/blockouts/$blockoutId/blockout_dates`
  static Future<PcoCollection<PcoServicesBlockoutDate>>
      getFromPersonAndBlockout(
    String personId,
    String blockoutId, {
    String? id,
    PcoServicesBlockoutDateQuery? query,
  }) async {
    query ??= PcoServicesBlockoutDateQuery();

    var url =
        '/services/v2/people/$personId/blockouts/$blockoutId/blockout_dates';
    if (id != null) url += '/$id';
    return PcoCollection.fromApiCall<PcoServicesBlockoutDate>(url,
        query: query, apiVersion: kApiVersion);
  }

  // little helper function
  T? _firstOrNull<T>(List? l) => l == null
      ? null
      : l.isEmpty
          ? null
          : l.cast<T>().first;
}
